﻿using System;
using System.ComponentModel;
using Wisej.Web;

namespace Wisej.Web.Ext.Uploader
{
    public partial class UploadControl : Wisej.Web.UserControl
    {
        public event CancelEventHandler FileOk;
        public UploadControl()
        {
            InitializeComponent();

            this.lbFileName.Text = string.Empty;
            this.lbStatus.Text = string.Empty;
        }

        private void uploader1_UploadProgress(object sender, UploaderProgressEventArgs e)
        {
            var percentComplete = (double)e.Loaded / (double)e.Total * 100.0;
            this.progressBar1.Value = (int)percentComplete;
            this.lbStatus.Text = $"Status{Environment.NewLine}Total Size:{FormatSize(this.uploader1.UploadFile.FileSize)}{Environment.NewLine}Transfer Rate:{FormatSize(e.TransferRate)}{Environment.NewLine}Percent Complete:{percentComplete.ToString("N2")}";
        }

        private void uploader1_OnCancelled(object sender, EventArgs e)
        {
            this.btnUpload.Enabled = true;
            this.uploader1.Enabled = true;
        }

        private void uploader1_OnFileReady(object sender, EventArgs e)
        {
            this.btnUpload.Enabled = true;
            this.lbFileName.Text = this.uploader1.UploadFile.FileName;
        }

        private void uploader1_OnStarted(object sender, EventArgs e)
        {
            this.btnCancel.Enabled = true;
            this.btnUpload.Enabled = false;
        }

        string FormatSize(long val)
        {
            string size = "0";

            if (val < 1)
            {
                return size;
            }

            if ((val / 1024 / 1024) > 1024)
                size = (val / 1024 / 1024 / 1024) + " gb";
            if ((val / 1024) > 1024)
                size = (val / 1024 / 1024) + " mb";
            else if (val > 1024)
                size = (val / 1024) + " kb";
            else
                size = val + " b";
            return size;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.btnCancel.Enabled = false;
            this.uploader1.Cancel();
        }

        private void btnUpload_Click(object sender, EventArgs e)
        {
            this.btnUpload.Enabled = false;
            this.uploader1.Enabled = false;
            this.uploader1.StartUpload();
        }

        private void uploader1_FileOk(object sender, CancelEventArgs e)
        {
            this.btnUpload.Enabled = true;
            this.uploader1.Enabled = true;
            this.btnCancel.Enabled = false;
            this.FileOk?.Invoke(sender, e);
        }
    }
}
